﻿------------------------------
--      Are you local?      --
------------------------------

local lady = BB["Lady Sacrolash"]
local lock = BB["Grand Warlock Alythess"]
local name = "The Eredar Twins Conflag/Nova"
local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..name)
local boss = BB["The Eredar Twins"]
local LBW = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)
local db = nil
local pName = UnitName("player")
local deaths = 0
local started = nil

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	cmd = "Conflag/Nova",

	enabled = "Enable Say",
	enabled_desc = "Turn on say when targetted with Conflag/Shadow Nova",
	
	nova = "Shadow Nova",
	nova_say = "Nova on me!",

	conflag = "Conflagration",
	conflag_say = "Conflag on me!",
} end )

L:RegisterTranslations("deDE", function() return {
	enabled = "Aktiviere Ankündigen",
	enabled_desc = "Aktiviere das Ankündigen(Sprechblase) wenn man selbst das Ziel von Großbrand/Schattennova ist.",
	
	nova = "Schattennova",
	nova_say = "Nova auf MIR!",

	conflag = "Großbrand",
	conflag_say = "Großbrand auf MIR!",
} end )

L:RegisterTranslations("zhCN", function() return {
	enabled = "启用喊话",
	enabled_desc = "当受到燃烧/新星时自动喊话警告周围队员。",
	
	nova = "暗影新星",
	nova_say = "我中了 >暗影新星<！",

	conflag = "燃烧",
	conflag_say = "我中了 >燃烧<！",
} end )

L:RegisterTranslations("koKR", function() return {
	enabled = "일반 대화 사용",
	enabled_desc = "거대한 불길/암흑 회오리의 대상이 되었을 때 일반 대화를 사용합니다.",
	
	nova = "암흑 회오리",
	nova_say = "나에게 회오리!",

	conflag = "거대한 불길",
	conflag_say = "나에게 거불!",
} end )

----------------------------------
--      Module Declaration      --
----------------------------------

local mod = BigWigs:NewModule(name)
mod.synctoken = name
mod.zonename = BZ["Sunwell Plateau"]
mod.enabletrigger = {lady, lock}
mod.toggleoptions = {"enabled"}
mod.revision = tonumber(("$Revision: 72332 $"):sub(12, -3))
mod.external = true

------------------------------
--      Initialization      --
------------------------------

function mod:OnEnable()
	self:RegisterEvent("CHAT_MSG_RAID_BOSS_EMOTE")
	self:AddCombatListener("UNIT_DIED", "Deaths")
	db = self.db.profile
	BigWigs:Print("Eredar Twins say warnings is enabled")
	self:RegisterEvent("PLAYER_REGEN_ENABLED", "CheckForWipe")
	self:RegisterEvent("PLAYER_REGEN_DISABLED", "CheckForEngage")
	deaths = 0
	started = nil
end

------------------------------
--      Event Handlers      --
------------------------------

function mod:CHAT_MSG_RAID_BOSS_EMOTE(_, unit, _, _, player)
	if unit == lady and db.enabled and deaths == 0 then
		if player == pName then
			SendChatMessage(L["nova_say"], "SAY")
		end
	elseif unit == lock and db.enabled and deaths == 0 then
		if player == pName then
			SendChatMessage(L["conflag_say"], "SAY")
		end
	-- Phase 2 the second boss gains the conflag/nova of the other and no longer does its own
	elseif unit == lady and db.enabled and deaths == 1 then
		if player == pName then
			SendChatMessage(L["conflag_say"], "SAY")
		end
	elseif unit == lock and db.enabled and deaths == 1 then
		if player == pName then
			SendChatMessage(L["nova_say"], "SAY")
		end
	end
end

function mod:Deaths(unit)
	if unit == lock or unit == lady then
		deaths = deaths + 1
	end
	if deaths == 2 then
		self:GenericBossDeath(boss, true)
	end
end

function mod:BigWigs_RecvSync(sync, rest, nick)
	if self:ValidateEngageSync(sync, rest) and not started then
		started = true
		deaths = 0
		if self:IsEventRegistered("PLAYER_REGEN_DISABLED") then
			self:UnregisterEvent("PLAYER_REGEN_DISABLED")
		end
	end
end
